//about 26 lines off?
#include <allegro.h>
#include <stdio.h>

unsigned char pbr;
unsigned short pc;
int spuskip=1;
int checkf000=0;
int hdmaena=1;
int rotozoom;
int inton=1;
unsigned char extbgenable;
int palf=0;
int v_line=0,vertcomp;
int frame=0;
PALETTE dospal;
int vblank;
int nmienable;
int intenable;
unsigned char *vram;
unsigned char ram[0x20000];
int seconds=0;
int fps,frames;
int vbline;


void countsecs()
{
        seconds++;
        fps=frames;
        frames=0;
}

static int speed_count=0;
static void incspeedcount()
{
        speed_count++;
}

void execsnes(int lines)
{
        while (!key[KEY_ESC])
        {
                while (speed_count>0)
                {
                        if (key[KEY_F1])
                        {
                                while (key[KEY_F1]) yield_timeslice();
                                reset65816();
                        }                                
                        vblank=0;
                        for (v_line=0;v_line<lines;v_line++)
                        {
                                if (v_line<224 && hdmaena) dohdma(v_line);
                                if (v_line==vbline)
                                {
                                        vblank=1;
                                        if (nmienable && !key[KEY_ESC])
                                           nmi65816();
                                }
                                if (v_line==vertcomp && intenable&0x20 && inton)
                                   int65816();
                                exec65816(256);
                                if (!spuskip) execspu(128);
                        }
                        speed_count--;
                }
                drawthescreen(0);
                blitthescreen();                
                if (key[KEY_F3])
                {
                        while (key[KEY_F3]);
                        hdmaena^=1;
                }                
                if (key[KEY_F12])
                {
                        while (key[KEY_F12]);
                        takescreenshot();
                }
        }
}

int main(int argc, char *argv[])
{
        int cycle;
        FILE *f;
/*        if (argc<2)
        {
                printf("Syntax : snes smcfile.smc\n");
                exit(-1);
        }*/
        loadsmc(argv[1]);
        if (argc>2)
        {
                if (!stricmp(argv[2],"-spc"))
                {
                        spuskip=0;
                        printf("SPC700 enabled\n");
                }
        }
        getch();
        if (palf) vbline=224;
        else      vbline=224;
        allegro_init();
        get_palette(dospal);
        install_timer();
        initvideo();
        install_keyboard();
        reset65816();
        resetspu();
        if (palf) install_int_ex(incspeedcount,MSEC_TO_TIMER(20));
        else      install_int_ex(incspeedcount,MSEC_TO_TIMER(16));
        install_int_ex(countsecs,MSEC_TO_TIMER(1000));
        if (palf) execsnes(312);
        else      execsnes(262);
        takescreenshot();
        set_palette(dospal);
        closevideo();
        allegro_exit();
        printf("65816 regs :\n");
        dumpregs();
        printf("SPC700 regs :\n");
        dumpspuregs();
        printf("PPU regs :\n");
        dumpppuregs();
        f=fopen("ram.dmp","wb");
        fwrite(ram,0x20000,1,f);
        fclose(f);
        return 0;
}

END_OF_MAIN();
